/***Test program functions of EEPROM for Bolt 18F2550***
requires the keypad and LCD connected to the system.
After reset, shows in the LCD a 2 digit number read from
locations in EEPROM for one second and then write the 
prompt ">". If the user types the letter "C", writes 
the word "CLAVE" in LCD and awaits a new 2-digit key
and stores it in the EEPROM. Later, if the user turns off
and turns on the system, the number displayed make sure 
the information was properly stored in EEPROM*/

#include <p18cxxx.h>
#include <delays.h>
#include "18F2550BOLT.h"

extern void _startup( void ); 
#pragma code _RESET_INTERRUPT_VECTOR = 0x000800 
void _reset( void ) 
{ 
    _asm goto _startup _endasm 
} 

#pragma code

char txt1[]="CLAVE:";
char C1,C2;

void main(void)

{
	init_bolt();		
	delay_ms(50);
	InitLCD();
	ClearScreen();
	GotoXY(0,0);
	PrintString(txt1);
	GotoXY(1,0);
	C1=readeeprom(0);
	C2=readeeprom(1);
	PutLCD(C1);
	PutLCD(C2);
	delay_ms(1000);
	ClearScreen();
	PutLCD('>');
	while(1)
	{
	boton=GetBot();				//la funcin GetBot() regresa con el ASCII de la tecla
		if(boton=='C')
		{
		PrintString(txt1);break;
		}
	}
	GotoXY(1,0);
	C1=GetBot();
	PutLCD(C1);
	C2=GetBot();
	PutLCD(C2);
	writeeeprom(0,C1);
	writeeeprom(1,C2);
	C1=readeeprom(0);
	C2=readeeprom(1);
	PutLCD('*');
	PutLCD(C1);
	PutLCD(C2);
	for(;;);
}
	



