/*Program to simulate the operation of pointers in MPLAB
Passes an array as a function parameter. Program defines
an array of 5 elements in ROM and then transfers each
element one by one, to another array in RAM, using pointers.
To simulate on MPLAB: compile program and use options:
>VIEW>WATCH>ADD SYMBOL and select variables from menu:
'arrayram','arrayrom','a',and 'p'. 
Then set a breakpoint at lines: b=0; for(;;);
and make simulation using command "RUN". The simulation will stop 
at the breakpoint.Repeat command "RUN" 4 more times and see the 
Watch window and the modification of the chosen variables,including
the pointer 'p'.The simulation will finally stop in the second 
breakpoint at line for(;;); To repeat simulation, recompile the 
program and use options >DEBUGGER>MEMORY CLEAR>ALL MEMORY 
to clear RAM and then start simulation again.*/


#include <p18cxxx.h>

extern void _startup( void ); // See c018i.c in your C18 compiler dir 
#pragma code _RESET_INTERRUPT_VECTOR = 0x000800 
void _reset( void ) 
{ 
    _asm goto _startup _endasm 
} 

#pragma code
void transfer(const rom int *p);
const rom int arrayrom[]={5,6,7,8,9};	//Define array in ROM
int arrayram[5];						//Define array inRAM
void main()
{
transfer(arrayrom);						//calls function and pass array as parameter
for(;;);								//final breakpoint goes here
} 

void transfer(const rom int *p)			//function receives array as a pointer
{int a,b;								//local variables
	for(a=0;a<5;a++)					//transfers 5 elements in array
	{
	arrayram[a]=*(p+a);					//addresses array in ROM with pointer
	b=0;								//dummy line to set breakpoint in simulation
	}	
}

